variables:
  PACKAGE_REGISTRY_URL: "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/u-boot-qca-haze"

build release:
  stage: build
  extends: .build
  rules:
    - if: '$CI_COMMIT_TAG =~ /^\d{4}\.\d{2}\.\d{2}-prpl$/'
  script:
    - rm -fr .git && make

upload:
  stage: release

  image: curlimages/curl:8.6.0
  needs: ["build release"]
  rules:
    - if: '$CI_COMMIT_TAG =~ /^\d{4}\.\d{2}\.\d{2}-prpl$/'

  script:
    - |
      release_filename="u-boot-${CI_COMMIT_TAG}.elfmbn"
      mv u-boot-*.elfmbn "$release_filename"
      curl \
        --header "JOB-TOKEN: ${CI_JOB_TOKEN}" \
        --upload-file "$release_filename" \
        ${PACKAGE_REGISTRY_URL}/${CI_COMMIT_TAG}/${release_filename}

release:
  stage: release

  image: registry.gitlab.com/gitlab-org/release-cli:v0.16.0
  needs: ["build release"]
  rules:
    - if: '$CI_COMMIT_TAG =~ /^\d{4}\.\d{2}\.\d{2}-prpl$/'

  script:
    - |
      awk '/## Release [0-9]{4}\.[0-9]{2}\.[0-9]{2}-prpl/ {print_flag=1 } /## Release [0-9]{4}\.[0-9]{2}\.[0-9]{2}-prpl/ && NR > 3 {print_flag=0} print_flag' CHANGELOG.md | tee description.txt
      release_filename="u-boot-${CI_COMMIT_TAG}.elfmbn"
      release-cli create \
        --name "U-Boot for Haze release ${CI_COMMIT_TAG}" \
        --tag-name $CI_COMMIT_TAG --ref $CI_COMMIT_SHA \
        --description description.txt \
        --assets-link "{\"name\":\"${release_filename}\",\"url\":\"${PACKAGE_REGISTRY_URL}/${CI_COMMIT_TAG}/${release_filename}\"}"
